<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<title>/home/tylerwbrown/Code/Personal/magical-joe-haskell/src/Add.hs</title>
</head>
<head>
<link type='text/css' rel='stylesheet' href='liquid.css' />
</head>

<body>
<hr>
Put mouse over identifiers to see inferred types
<pre><span class=hs-linenum> 1: </span><a class=annot href="#"><span class=annottext>GHC.Types.Module</span><span class='hs-keyword'>module</span></a> <span class='hs-conid'>Add</span> <span class='hs-keyword'>where</span>
<span class=hs-linenum> 2: </span>
<span class=hs-linenum> 3: </span><span class='hs-keyword'>{-@</span> <span class='hs-keyword'>type</span> <span class='hs-conid'>NonEmpty</span> <span class='hs-varid'>a</span> <span class='hs-keyglyph'>=</span> <span class='hs-layout'>{</span><span class='hs-varid'>v</span><span class='hs-conop'>:</span><span class='hs-keyglyph'>[</span><span class='hs-varid'>a</span><span class='hs-keyglyph'>]</span> <span class='hs-keyglyph'>|</span> <span class='hs-varid'>len</span> <span class='hs-varid'>v</span> <span class='hs-varop'>&gt;=</span> <span class='hs-num'>0</span> <span class='hs-layout'>}</span> <span class='hs-keyword'>@-}</span>
<span class=hs-linenum> 4: </span>
<span class=hs-linenum> 5: </span><span class='hs-keyword'>data</span> <span class='hs-conid'>Digit</span> <span class='hs-keyglyph'>=</span> 
<span class=hs-linenum> 6: </span>  <span class='hs-conid'>Zero</span> <span class='hs-keyglyph'>|</span> <span class='hs-conid'>One</span> <span class='hs-keyglyph'>|</span> <span class='hs-conid'>Two</span> <span class='hs-keyglyph'>|</span> <span class='hs-conid'>Three</span> <span class='hs-keyglyph'>|</span> <span class='hs-conid'>Four</span> <span class='hs-keyglyph'>|</span> <span class='hs-conid'>Five</span> <span class='hs-keyglyph'>|</span> <span class='hs-conid'>Six</span> <span class='hs-keyglyph'>|</span> <span class='hs-conid'>Seven</span> <span class='hs-keyglyph'>|</span> <span class='hs-conid'>Eight</span> <span class='hs-keyglyph'>|</span> <span class='hs-conid'>Nine</span> 
<span class=hs-linenum> 7: </span>  <span class='hs-keyword'>deriving</span> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>(GHC.Classes.Eq Add.Digit)</span><span class='hs-conid'>Eq</span></a><span class='hs-layout'>,</span> <a class=annot href="#"><span class=annottext>(GHC.Classes.Ord Add.Digit)</span><span class='hs-conid'>Ord</span></a><span class='hs-layout'>,</span> <span class=hs-error><a class=annot href="#"><span class=annottext>(GHC.Enum.Enum Add.Digit)</span><span class='hs-conid'>Enum</span></a></span><span class='hs-layout'>,</span> <a class=annot href="#"><span class=annottext>(GHC.Show.Show Add.Digit)</span><span class='hs-conid'>Show</span></a><span class='hs-layout'>)</span>
<span class=hs-linenum> 8: </span>
<span class=hs-linenum> 9: </span><a class=annot href="#"><span class=annottext>a -&gt; (a -&gt; b) -&gt; b</span><span class='hs-layout'>(</span></a><span class='hs-varop'>|&gt;</span><span class='hs-layout'>)</span> <a class=annot href="#"><span class=annottext>a</span><span class='hs-varid'>x</span></a> <a class=annot href="#"><span class=annottext>a -&gt; b</span><span class='hs-varid'>f</span></a> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{v : a -&gt; b | v == f}</span><span class='hs-varid'>f</span></a> <span class='hs-varid'>x</span>
<span class=hs-linenum>10: </span>
<span class=hs-linenum>11: </span>
<span class=hs-linenum>12: </span><span class='hs-keyword'>{-@</span> <span class='hs-varid'>add</span> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>NonEmpty</span> <span class='hs-conid'>Digit</span> <span class='hs-keyglyph'>-&gt;</span> <span class='hs-conid'>NonEmpty</span> <span class='hs-conid'>Digit</span> <span class='hs-keyglyph'>-&gt;</span> <span class='hs-keyglyph'>[</span><span class='hs-conid'>Digit</span><span class='hs-keyglyph'>]</span> <span class='hs-keyword'>@-}</span>
<span class=hs-linenum>13: </span><a class=annot href="#"><span class=annottext>{v : [Add.Digit] | len v &gt;= 0} -&gt; {v : [Add.Digit] | len v &gt;= 0} -&gt; [Add.Digit]</span><span class='hs-definition'>add</span></a> <span class='hs-conid'>[]</span> <span class='hs-conid'>[]</span> <span class='hs-keyglyph'>=</span> <span class='hs-keyglyph'>[</span><span class='hs-conid'>Zero</span><span class='hs-keyglyph'>]</span>
<span class=hs-linenum>14: </span><span class='hs-definition'>add</span> <span class='hs-varid'>xs</span> <span class='hs-conid'>[]</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>xs</span>
<span class=hs-linenum>15: </span><span class='hs-definition'>add</span> <span class='hs-conid'>[]</span> <span class='hs-varid'>ys</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>ys</span>
<span class=hs-linenum>16: </span><span class='hs-definition'>add</span> <span class='hs-varid'>xs</span> <span class='hs-varid'>ys</span>
<span class=hs-linenum>17: </span>  <span class='hs-keyglyph'>|</span> <a class=annot href="#"><span class=annottext>(Add.Digit -&gt; GHC.Types.Bool) -&gt; [Add.Digit] -&gt; GHC.Types.Bool</span><span class='hs-varid'>all</span></a> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>(GHC.Classes.Eq Add.Digit)</span><span class='hs-varop'>==</span></a> <span class='hs-conid'>Zero</span><span class='hs-layout'>)</span> <span class='hs-varid'>ys</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>xs</span>
<span class=hs-linenum>18: </span>  <span class='hs-keyglyph'>|</span> <span class='hs-varid'>otherwise</span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{v : [Add.Digit] | len v &gt;= 0} -&gt; {v : [Add.Digit] | len v &gt;= 0} -&gt; [Add.Digit]</span><span class='hs-varid'>add</span></a> <span class='hs-layout'>(</span><span class=hs-error><a class=annot href="#"><span class=annottext>{v : [Add.Digit] -&gt; [Add.Digit] | v == Add.successor}</span><span class='hs-varid'>successor</span></a></span><span class=hs-error> </span><span class=hs-error><span class='hs-varid'>xs</span></span><span class='hs-layout'>)</span> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>{v : [Add.Digit] -&gt; [Add.Digit] | v == Add.predecessor}</span><span class='hs-varid'>predecessor</span></a> <span class='hs-varid'>ys</span><span class='hs-layout'>)</span>
<span class=hs-linenum>19: </span>
<span class=hs-linenum>20: </span><a class=annot href="#"><span class=annottext>[Add.Digit] -&gt; [Add.Digit]</span><span class='hs-definition'>successor</span></a> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{v : Add.Digit -&gt; Add.Digit -&gt; Add.Digit -&gt; (Add.Digit -&gt; Add.Digit) -&gt; [Add.Digit] -&gt; [Add.Digit] | v == Add.move}</span><span class='hs-varid'>move</span></a> <span class='hs-conid'>One</span> <span class='hs-conid'>Zero</span> <span class='hs-conid'>Nine</span> <span class='hs-varid'>succ</span>
<span class=hs-linenum>21: </span><a class=annot href="#"><span class=annottext>[Add.Digit] -&gt; [Add.Digit]</span><span class='hs-definition'>predecessor</span></a> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{v : Add.Digit -&gt; Add.Digit -&gt; Add.Digit -&gt; (Add.Digit -&gt; Add.Digit) -&gt; [Add.Digit] -&gt; [Add.Digit] | v == Add.move}</span><span class='hs-varid'>move</span></a> <span class='hs-conid'>Zero</span> <span class='hs-conid'>Nine</span> <span class='hs-conid'>Zero</span> <span class='hs-varid'>pred</span>
<span class=hs-linenum>22: </span>
<span class=hs-linenum>23: </span><a class=annot href="#"><span class=annottext>Add.Digit -&gt; Add.Digit -&gt; Add.Digit -&gt; (Add.Digit -&gt; Add.Digit) -&gt; [Add.Digit] -&gt; [Add.Digit]</span><span class='hs-definition'>move</span></a> <a class=annot href="#"><span class=annottext>Add.Digit</span><span class='hs-varid'>emptyNum</span></a> <a class=annot href="#"><span class=annottext>Add.Digit</span><span class='hs-varid'>min</span></a> <a class=annot href="#"><span class=annottext>Add.Digit</span><span class='hs-varid'>max</span></a> <a class=annot href="#"><span class=annottext>Add.Digit -&gt; Add.Digit</span><span class='hs-varid'>change</span></a> <a class=annot href="#"><span class=annottext>[Add.Digit]</span><span class='hs-varid'>digits</span></a> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>x1:[Add.Digit] -&gt; {v : [Add.Digit] | len v &lt;= len x1}</span><span class='hs-varid'>dropWhile</span></a> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>(GHC.Classes.Eq Add.Digit)</span><span class='hs-varop'>==</span></a> <span class='hs-conid'>Zero</span><span class='hs-layout'>)</span> <span class='hs-varop'>$</span> <span class='hs-keyword'>case</span> <span class='hs-varid'>start</span> <span class='hs-keyword'>of</span>
<span class=hs-linenum>24: </span>  <span class='hs-conid'>[]</span> <span class='hs-keyglyph'>-&gt;</span> <a class=annot href="#"><span class=annottext>{v : [Add.Digit] | head v == emptyNum}</span><span class='hs-keyglyph'>[</span></a><span class='hs-varid'>emptyNum</span><span class='hs-keyglyph'>]</span> <span class='hs-varop'>++</span> <span class='hs-varid'>end</span>
<span class=hs-linenum>25: </span>  <span class='hs-layout'>(</span><span class='hs-varid'>x</span><span class='hs-conop'>:</span><span class='hs-varid'>xs</span><span class='hs-layout'>)</span> <span class='hs-keyglyph'>-&gt;</span> <a class=annot href="#"><span class=annottext>[Add.Digit]</span><span class='hs-layout'>(</span></a><a class=annot href="#"><span class=annottext>{v : [Add.Digit] | len v == len xs}</span><span class='hs-varid'>reverse</span></a> <span class='hs-varid'>xs</span><span class='hs-layout'>)</span> <span class='hs-varop'>++</span> <span class='hs-keyglyph'>[</span><a class=annot href="#"><span class=annottext>{v : Add.Digit -&gt; Add.Digit | v == change}</span><span class='hs-varid'>change</span></a> <span class='hs-varid'>x</span><span class='hs-keyglyph'>]</span> <span class='hs-varop'>++</span> <span class='hs-varid'>end</span>
<span class=hs-linenum>26: </span>  <span class='hs-keyword'>where</span>
<span class=hs-linenum>27: </span>    <a class=annot href="#"><span class=annottext>(a -&gt; GHC.Types.Bool) -&gt; [a] -&gt; ([a], [a])</span><span class='hs-varid'>takeAndDrop</span></a> <a class=annot href="#"><span class=annottext>a -&gt; GHC.Types.Bool</span><span class='hs-varid'>check</span></a> <a class=annot href="#"><span class=annottext>[a]</span><span class='hs-varid'>xs</span></a> <span class='hs-keyglyph'>=</span> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>x1:[a] -&gt; {v : [a] | len v &lt;= len x1}</span><span class='hs-varid'>takeWhile</span></a> <span class='hs-varid'>check</span> <span class='hs-varid'>xs</span><span class='hs-layout'>,</span> <a class=annot href="#"><span class=annottext>x1:[a] -&gt; {v : [a] | len v &lt;= len x1}</span><span class='hs-varid'>dropWhile</span></a> <span class='hs-varid'>check</span> <span class='hs-varid'>xs</span><span class='hs-layout'>)</span>
<span class=hs-linenum>28: </span>    <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>[Add.Digit]</span><span class='hs-varid'>end</span></a><span class='hs-layout'>,</span> <a class=annot href="#"><span class=annottext>[Add.Digit]</span><span class='hs-varid'>start</span></a><span class='hs-layout'>)</span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{v : [Add.Digit] | len v == len digits}</span><span class='hs-varid'>reverse</span></a> <span class='hs-varid'>digits</span> <span class='hs-varop'>|&gt;</span> <a class=annot href="#"><span class=annottext>[Add.Digit] -&gt; ([Add.Digit], [Add.Digit])</span><span class='hs-varid'>takeAndDrop</span></a> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>(GHC.Classes.Eq Add.Digit)</span><span class='hs-varop'>==</span></a> <span class='hs-varid'>max</span><span class='hs-layout'>)</span> <span class='hs-varop'>|&gt;</span>
<span class=hs-linenum>29: </span>      <span class='hs-keyglyph'>\</span><span class='hs-layout'>(</span><span class='hs-varid'>xs</span><span class='hs-layout'>,</span> <span class='hs-varid'>ys</span><span class='hs-layout'>)</span> <span class='hs-keyglyph'>-&gt;</span> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>Add.Digit -&gt; {v : Add.Digit | v == min}</span><span class='hs-varid'>map</span></a> <span class='hs-layout'>(</span><span class='hs-keyglyph'>\</span><span class='hs-keyword'>_</span> <span class='hs-keyglyph'>-&gt;</span> <span class='hs-varid'>min</span><span class='hs-layout'>)</span> <span class='hs-varid'>xs</span><span class='hs-layout'>,</span> <span class='hs-varid'>ys</span><span class='hs-layout'>)</span>
<span class=hs-linenum>30: </span>
</pre>
</body>
</html>